#ifndef __FLAG_ADS1100
#define __FLAG_ADS1100
#endif //__FLAG_ADS1100

#ifdef _CODEVISION
#ifndef _DELAY_INCLUDED_
#include <delay.h>      
#endif //_DELAY_INCLUDED_
#endif //_CODEVISION

#ifdef _AVR_ATMEGA8
#ifndef __FLAG_SETTWI
#include "mega8/setTWI.h"
#endif //__FLAG_SETTWI

unsigned char translateADS1100(unsigned char );
int getADS1100Value(unsigned char );
void setADS1100Config(unsigned char , int );

void initADS1100(void)
{
	setTWIPrescaler(1);
	setTWIBitRate(400.0);
	setTWIEnable();
}

unsigned char translateADS1100(unsigned char address)
{
	// AD0 : 0
	// AD1 : 2
	return (BM_1001_0000 | address);
}


int getADS1100Value(unsigned char addressADS1100)
{
	//value = ADS1100  Ʈ 7   .
	//ATKv1r3 Vin+ = 0V, Vin- = sensor, Vdd = 5V̰,
	//PGA  ⺻ 1  ,
	//output = INT( sensor * (-1*power(2,scale-1)/5))
	//sensor = output / ( -1*POWER(2, scale - 1) / 5 )
	//output :  
	//sensor :   
	//scale : ش
	//
	//< ATKv1r3  >
	//1.  2V ̰, 16Hz ø ,
	//sensor = 2, scale = 15
	//output = INT(2 * ( -1*power(2, 15 - 1) / 5 ))
	//	= -6554
	//return value = 6552
	//
	//2. 16Hz ø  , ° 1  ,
	//scale = 15
	//sensor = 1/( -1*POWER(2, 15 - 1) / 5 )
	//  0.3mV 
	//
	//3. 16Hz ø  , ° 1  ,
	//scale = 15
	//sensor = -1/( -1*POWER(2, 15 - 1) / 5 )
	//  0.3mV 
	//
	//4. ø ļ  ADC 1  ȭ
	//ø ļ,	ش,	V,	mV
	//8	16	-0.000152588	-0.152587891
	//16	15	-0.000305176	-0.305175781
	//32	14	-0.000610352	-0.610351563
	//128	12	-0.002441406	-2.44140625

	unsigned char address;
	unsigned char data1 = 0;    
	unsigned char data2 = 0;    
	unsigned char config = 0;    

	int value = 0;

	address = translateADS1100(addressADS1100);

	setTWIMasterStart();

	setTWIMasterReadSelectSlave(address);

	//ù°  Ʈ ޴´.
	data1 = setTWIMasterReadWaitReceive1();    

	//ι°  Ʈ ޴´.
	data2 = setTWIMasterReadWaitReceive1();

	//Configuration Ʈ ޴´.
	config = setTWIMasterReadWaitReceive1();

	setTWIMasterEnd();

	value = data1;
	value = (value << 8) + data2;	//value = output

	value = ~(value + 1);	//ADC   2 ̱ .

	return value;
}

void setADS1100Config(unsigned char addressADS1100, int samplingFreq)
{
	unsigned char address = 0;
	unsigned char config = 0;
	address = translateADS1100(addressADS1100);

	setTWIMasterStart();

	setTWIMasterWriteSelectSlave(address);

	//config ͸ Ѵ.
	config = BM_1000_0000
		// ȯ 
		//| BM_0001_0000	//continuous conversion mode
		| BM_0000_0000	//single conversion mode, default

		// ø ֱ
		//| BM_0000_1100	//8SPS, 16bits, default
		| BM_0000_1000	//16SPS, 15bits
		//| BM_0000_0100	//32SPS, 14bits
		//| BM_0000_0000	//128SPS, 12bits

		// ADC 
		//| BM_0000_0011	//gain 8
		//| BM_0000_0010	//gain 4
		//| BM_0000_0001	//gain 2
		| BM_0000_0000	//gain 1, default
		;

	switch(samplingFreq)
	{
		case 8:
			config &= BM_1111_0011;
			config |= BM_0000_1100;
			break;

		case 16:
			config &= BM_1111_0011;
			config |= BM_0000_1000;
			break;

		case 32:
			config &= BM_1111_0011;
			config |= BM_0000_0100;
			break;

		case 128:
			config &= BM_1111_0011;
			config |= BM_0000_0000;
			break;

		default:
			config &= BM_1111_0011;
			config |= BM_0000_1100;
			break;
	}


	setTWIMasterWriteData(config);
	setTWIMasterEnd();
}


#endif //_AVR_ATMEGA8


#ifdef _AVR_ATMEGA2560
#ifndef __FLAG_SETTWI
#include "mega2560/setTWI.h"
#endif //__FLAG_SETTWI



#endif //_AVR_ATMEGA2560
