#ifndef __FLAG_SETTWI
#define __FLAG_SETTWI
#endif //__FLAG_SETTWI

void setTWIPrescaler(int prescaler)
{
	switch (prescaler)
	{
		case	1:
			TWSR &= BM_1111_1100;
			break;
		case	4:
			TWSR &= BM_1111_1101;
			break;
		case	16:
			TWSR &= BM_1111_1110;
			break;
		case	64:
			TWSR &= BM_1111_1111;
			break;
	}
}

void setTWIBitRate(float bitrateKHz)
{
	//ATmega8 ͽƮ 167ʿ SCL ļ   ִ.
	//  128 237ʿ ִ.
	//⼭  , TWPS  ֺ Ÿ  ƴ϶, Ʈ ״θ ǹѴ.
	//, TWSR 0,1 Ʈ 00 Ǿ, ֺ 1ε, f_scl Ŀ 0 Ѵ.
	//
	//⼭ 16MHz  ý Ŭ ϰ ִٰ Ѵ.

	TWBR = (unsigned char)(((16000.0 / bitrateKHz) - 16.0)/( 1<<(2*(TWSR&0x03)+1) ));
}

void setTWISlaveAddress(char address)
{
	TWAR = address;
}

#define TWEA	6
void setTWIEnableAcknowledgeBit(void)
{
	TWCR |= 1 << TWEA;
	//TWCR |= BM_0100_0000;
}

#define TWEN	2
void setTWIEnable(void)
{
	TWCR |= 1 << TWEN;
	//TWCR |= BM_0000_0100;
}

void initTWI(void)
{
	setTWIPrescaler(1);
	setTWIBitRate(400.0);
	setTWIEnable();
}


void setTWIMasterStart(void)
{
	//TWINT	TWEA	TWSTA	TWSTO	TWWC	TWEN	 --	TWIE
	//1	0	1	0	0	1	0	0
	TWCR |= BM_1010_0100;
	while(
			( 
				((TWCR & BM_1000_0000) == BM_0000_0000)	//TWINT = 1?
				||
				((TWSR & BM_1111_1000) != BM_0000_1000)	//TWSR = 0x08?
			 )
		 );

}



void setTWIMasterReadSelectSlave(unsigned char address)
{
	TWDR = address + 0x01;	//Address(SLA) + R
	TWCR = 0x84;    //ּҰ . Ȯ Ǹ Ackȣ .                                        

	while(
			( 
				((TWCR & BM_1000_0000) == BM_0000_0000)	//TWINT = 1?
				||
				((TWSR & BM_1111_1000) != BM_0100_0000)	//TWSR = 0x40?
			 )
		 );
}

void setTWIMasterWriteSelectSlave(unsigned char address)
{
	TWDR = address + 0x00;	//Address(SLA) + \W
	TWCR = 0x84;    //ּҰ . Ȯ Ǹ Ackȣ .                                        

	while(
			( 
				((TWCR & BM_1000_0000) == BM_0000_0000)	//TWINT = 1?
				||
				((TWSR & BM_1111_1000) != BM_0001_1000)	//TWSR = 0x18?
			 )
		 );

}



unsigned char setTWIMasterReadWaitReceive0(void)
{
	//read data with no acknowledge
	unsigned char rcvData = 0;

	TWCR = BM_1000_0100;    //   , TWEA = 0
	//TWEA 0̸  Ŀ ȮκƮ µ ʾ TWINT 1 Ǹ鼭 TWSR 0x58 ȴ.
	//TWEA 1̸  Ŀ ȮκƮ µǾ TWINT 1 Ǹ鼭 TWSR 0x50 ȴ.
	while( 
			(
				((TWCR & BM_1000_0000) == BM_0000_0000)	//TWINT = 1?
				||
				((TWSR & BM_1111_1000) != BM_0101_1000)	//TWSR = 0x58?
			 )
		 );                             

	rcvData = TWDR;

	return rcvData;
}



unsigned char setTWIMasterReadWaitReceive1(void)
{
	//read data with acknowledge
	unsigned char rcvData = 0;

	TWCR = BM_1100_0100;    //   , TWEA = 1
	//TWEA 0̸  Ŀ ȮκƮ µ ʾ TWINT 1 Ǹ鼭 TWSR 0x58 ȴ.
	//TWEA 1̸  Ŀ ȮκƮ µǾ TWINT 1 Ǹ鼭 TWSR 0x50 ȴ.
	while( 
			(
				((TWCR & BM_1000_0000) == BM_0000_0000)	//TWINT = 1?
				||
				((TWSR & BM_1111_1000) != BM_0101_0000)	//TWSR = 0x50?
			 )
		 );                             

	rcvData = TWDR;

	return rcvData;
}

void setTWIMasterEnd(void)
{
	// 
	TWCR = 0x94;    // .
}

void setTWIMasterWriteData(unsigned char config)
{
	TWDR = config;
	TWCR = BM_1000_0100;

	while(
			( 
				((TWCR & BM_1000_0000) == BM_0000_0000)	//TWINT = 1?
				||
				((TWSR & BM_1111_1000) != BM_0010_1000)	//TWSR = 0x28?
			 )
		 );

}

